#ifndef MOJETTE_HPP_
#define MOJETTE_HPP_

/** 
 * \mainpage Libmojette
 *
 * The Mojette Transform is a discrete Radon Transform defined for specific projections.
 * The Mojette transform is widely used for several digital image processing applications, such as :
 * - Data transmission.
 * - Quality of service.
 * - 'n' Dimension Image processing.
 * - Image Watermarking.
 * - Image Cryptography.
 * - Image Steganography.
 * - ...probably many other applications we haven't already found. 
 */
 
#include "Angle.hpp"
#include "Operator.hpp"
#include "Transform.hpp"
#include "DiracTransform.hpp"

#endif
