// Copyright 2006-2007 Pierre Evenou
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// pierre.evenou@univ-nantes.fr

#ifndef RATIONAL_HPP_
#define RATIONAL_HPP_

#include <iostream>

namespace Mojette
{

/**
 * \brief Rational.
 * 
 * Used by HaarTransform. 
 */
class Rational
{
public:

    Rational();
    
    Rational(int num);
    
    Rational(int num, int den);

    Rational operator +(const Rational& r) const;
    
    Rational& operator +=(const Rational& r);
    
    Rational operator -(const Rational& r) const;
    
    Rational& operator -=(const Rational& r);
    
    Rational operator *(const Rational& r) const;
    
    Rational& operator *=(const Rational& r);
    
    Rational operator /(const Rational& r) const;
    
    Rational& operator /=(const Rational& r);
    
    operator double();

    void reduce();

    int getNum() const;
    
    int getDen() const;

private:

    int mNum;
    
    int mDen;
};

std::ostream &operator<<(std::ostream &ostrm, const Rational& r);
}

#endif
