// Copyright 2006-2007 Pierre Evenou
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// pierre.evenou@univ-nantes.fr

#include "TestAngle.hpp"

void
TestAngle::setUp()
{
    mA1 = new Mojette::Angle(28, 16);
    mA2 = new Mojette::Angle(7, 4);
    mA3 = new Mojette::Angle(1, 1);
    mA4 = new Mojette::Angle(0, 1);
    mA5 = new Mojette::Angle(-1, 1);
}

void
TestAngle::tearDown()
{
    delete mA1;
    delete mA2;
    delete mA3;
    delete mA4;
    delete mA5;
}

void
TestAngle::testCtor()
{
    CPPUNIT_ASSERT(mA1->getP() == 7 && mA1->getQ() == 4);
}

void
TestAngle::testSetP()
{
    mA1->setP(6);
    CPPUNIT_ASSERT(mA1->getP() == 3 && mA1->getQ() == 2);
}

void
TestAngle::testSetQ()
{
    mA1->setQ(7);
    CPPUNIT_ASSERT(mA1->getP() == 1 && mA1->getQ() == 1);
}

void
TestAngle::testEqual()
{
    CPPUNIT_ASSERT(*mA1 == *mA2);
}

void
TestAngle::testNotEqual()
{
    CPPUNIT_ASSERT(*mA3 != *mA4);
}

void
TestAngle::testGreaterThan()
{
    CPPUNIT_ASSERT(*mA4 > *mA3);
}

void
TestAngle::testLesserThan()
{
    CPPUNIT_ASSERT(*mA4 < *mA5);
}

