// Copyright 2006-2007 Pierre Evenou
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// pierre.evenou@univ-nantes.fr

#ifndef TESTANGLE_HPP_
#define TESTANGLE_HPP_

#include <cppunit/extensions/HelperMacros.h>

#include "Angle.hpp"

class TestAngle : public CppUnit::TestFixture
{
    
CPPUNIT_TEST_SUITE(TestAngle);
CPPUNIT_TEST(testCtor);
CPPUNIT_TEST(testSetP);
CPPUNIT_TEST(testSetQ);
CPPUNIT_TEST(testEqual);
CPPUNIT_TEST(testNotEqual);
CPPUNIT_TEST(testGreaterThan);
CPPUNIT_TEST(testLesserThan);
CPPUNIT_TEST_SUITE_END();

public :
    void setUp();
    void tearDown();
    
protected :
    void testCtor();
    void testSetP();
    void testSetQ();
    void testEqual();
    void testNotEqual();
    void testGreaterThan();
    void testLesserThan();
    
private :
    Mojette::Angle* mA1;
    Mojette::Angle* mA2;
    Mojette::Angle* mA3;
    Mojette::Angle* mA4;
    Mojette::Angle* mA5;
};

#endif
