#include "TestDiracTransform.hpp"

void
TestDiracTransform::setUp()
{
    int t[] = {3, 1, 4, 1, 5, 9, 2, 6, 5, 3, 5, 9};
    mSupport.assign(t, t+12);
    
    mAngles.push_back(Mojette::Angle(-1 , 1));
    mAngles.push_back(Mojette::Angle( 0 , 1));
    mAngles.push_back(Mojette::Angle( 1 , 1));
    
    int p1[] = {5, 8, 17, 12, 10, 1};
    std::vector<int> vp1(p1, p1 + 6);
    mProjections.push_back(vp1);
    int p2[] = {13, 13, 11, 16};
    std::vector<int> vp2(p2, p2 + 4);
    mProjections.push_back(vp2);
    int p3[] = {3, 6, 18, 6, 11, 9};
    std::vector<int> vp3(p3, p3 + 6);
    mProjections.push_back(vp3);
}

void
TestDiracTransform::tearDown()
{
}

void 
TestDiracTransform::testForward()
{
    Mojette::DiracTransform<int, int, Mojette::ADD> dt(3, 4);
    std::vector<std::vector<int> >* prjs = dt.forward(mAngles, mSupport);
    CPPUNIT_ASSERT(*prjs == mProjections);
}

void
TestDiracTransform::testInverse()
{
    Mojette::DiracTransform<int, int, Mojette::ADD> dt(3, 4);
    std::vector<int>* rec = dt.inverse(mAngles, mProjections);
    CPPUNIT_ASSERT(*rec == mSupport);
}
