// Copyright 2006-2007 Pierre Evenou
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
// pierre.evenou@univ-nantes.fr

#ifndef TESTDIRACTRANSFORM_HPP_
#define TESTDIRACTRANSFORM_HPP_

#include <cppunit/extensions/HelperMacros.h>

#include "Angle.hpp"
#include "DiracTransform.hpp"

class TestDiracTransform : public CppUnit::TestFixture
{
    
CPPUNIT_TEST_SUITE(TestDiracTransform);
CPPUNIT_TEST(testForward);
CPPUNIT_TEST(testInverse);
CPPUNIT_TEST_SUITE_END();

public :
    void setUp();
    void tearDown();
    
protected :
    void testForward();
    void testInverse();
    
private :
    std::vector<int> mSupport;
    std::vector<Mojette::Angle> mAngles;
    std::vector<std::vector<int> > mProjections;
};

#endif
